library angular2.src.change_detection.binding_propagation_config;

import "interfaces.dart" show ChangeDetector;
import "constants.dart"
    show
        CHECK_ONCE,
        DETACHED,
        CHECK_ALWAYS; /**
 * @exportedAs angular2/change_detection
 */

class BindingPropagationConfig {
  ChangeDetector _cd;
  BindingPropagationConfig(ChangeDetector cd) {
    this._cd = cd;
  }
  shouldBePropagated() {
    this._cd.mode = CHECK_ONCE;
  }
  shouldBePropagatedFromRoot() {
    this._cd.markPathToRootAsCheckOnce();
  }
  shouldNotPropagate() {
    this._cd.mode = DETACHED;
  }
  shouldAlwaysPropagate() {
    this._cd.mode = CHECK_ALWAYS;
  }
}
