library angular2.src.core.annotations.view;

import "package:angular2/src/facade/lang.dart"
    show
        ABSTRACT,
        CONST,
        Type; /**
 * Declare the available HTML templates for an application.
 *
 * Each angular component requires a single `@Component` and at least one `@View` annotation. The @View
 * annotation specifies the HTML template to use, and lists the directives that are active within the template.
 *
 * When a component is instantiated, the template is loaded into the component's shadow root, and the
 * expressions and statements in the template are evaluated against the component.
 *
 * For details on the `@Component` annotation, see [Component].
 *
 * ## Example
 *
 * ```
 * @Component({
 *   selector: 'greet'
 * })
 * @View({
 *   template: 'Hello {{name}}!',
 *   directives: [GreetUser, Bold]
 * })
 * class Greet {
 *   name: string;
 *
 *   constructor() {
 *     this.name = 'World';
 *   }
 * }
 * ```
 *
 * @exportedAs angular2/annotations
 */

class View {
  final dynamic templateUrl;
  final dynamic template;
  final dynamic directives;
  final dynamic formatters;
  final dynamic source;
  final dynamic locale;
  final dynamic device;
  @CONST() const View(
      {templateUrl, template, directives, formatters, source, locale, device})
      : templateUrl = templateUrl,
        template = template,
        directives = directives,
        formatters = formatters,
        source = source,
        locale = locale,
        device = device;
}
