library angular2.test.core.compiler.dynamic_component_loader_spec;

import "package:angular2/test_lib.dart"
    show ddescribe, describe, it, iit, expect, beforeEach;
import "package:angular2/src/core/compiler/directive_metadata_reader.dart"
    show DirectiveMetadataReader;
import "package:angular2/src/core/compiler/dynamic_component_loader.dart"
    show DynamicComponentLoader, DirectiveRef;
import "package:angular2/src/core/annotations/annotations.dart"
    show Decorator, Viewport;

@Decorator(selector: "someDecorator")
class SomeDecorator {}
@Viewport(selector: "someViewport")
class SomeViewport {}
main() {
  describe("DynamicComponentLoader", () {
    var loader;
    beforeEach(() {
      loader = new DynamicComponentLoader(
          null, new DirectiveMetadataReader(), null, null);
    });
    describe("loadIntoExistingLocation", () {
      describe("Load errors", () {
        it("should throw when trying to load a decorator", () {
          expect(() => loader.loadIntoExistingLocation(
                  SomeDecorator, null)).toThrowError(
              "Could not load 'SomeDecorator' because it is not a component.");
        });
        it("should throw when trying to load a viewport", () {
          expect(() => loader.loadIntoExistingLocation(
                  SomeViewport, null)).toThrowError(
              "Could not load 'SomeViewport' because it is not a component.");
        });
      });
    });
  });
}
